import org.codehaus.groovy.scriptom.ActiveXObject
import org.codehaus.groovy.scriptom.Scriptom

import com.jacob.com.Variant

final def varientNull = Variant.VariantNull

def exitcode = 0

try {
	Scriptom.inApartment{
	    def testDirector = null
	    
        final def stepProps = new Properties();
        final def inputPropsFile = new File(args[0]);
        final def inputPropsStream = null;
        try {
            inputPropsStream = new FileInputStream(inputPropsFile);
            stepProps.load(inputPropsStream);
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }

	    def serverUrl = stepProps['serverUrl']
	    println 'SERVER: ' + serverUrl
	    def username = stepProps['username']
		def password = stepProps['password'] ? stepProps['password'] : stepProps['passwordscript']
		def domain = stepProps['qcdomain']
	    def project = stepProps['qcproject']
        println "Project = $project";
		
	    def issuePropsStr = stepProps['props']
	
		// parse the additional fields into a Properties object
		def updateFields = new Properties()
		if (issuePropsStr != null) {
			try {
	            updateFields.load(new ByteArrayInputStream(issuePropsStr.getBytes()))
	        }
	        catch (Exception e) {
	            throw new Exception("Additional fields formatted incorrectly: " + e.getMessage())
	        }
		}
	
		// add the defined fields that can be updated to the Properties object
		if (stepProps['assignee']) {
			updateFields.setProperty("AssignedTo", stepProps['assignee'])
		}
		if (stepProps['summary']) {
			updateFields.setProperty("Summary", stepProps['summary'])
		}
		if (stepProps['priority']) {
			updateFields.setProperty("Priority", stepProps['priority'])
		}
		if (stepProps['status']) {
			updateFields.setProperty("Status", stepProps['status'])
		}
		if (stepProps['severity']) {
			updateFields.setProperty("BG_SEVERITY", stepProps['severity'])
		}
		if (stepProps['qcprojectkey']) {
			updateFields.setProperty("Project", stepProps['qcprojectkey'])
		}
		if (stepProps['detectedby']) {
			updateFields.setProperty("DetectedBy", stepProps['detectedby'])
		}
		
		try {
			println 'Creating connection to Quality Center server'
		    testDirector = new ActiveXObject("TDApiOle80.TDConnection")
		    testDirector.InitConnectionEx(serverUrl)
		    testDirector.Login(username, password)
		    testDirector.Connect(domain, project)
		    println 'Connection established'
	    
	        def bugFactory = testDirector.BugFactory 
	        def bug = bugFactory.addItem(varientNull)
			println 'Creating defect ' + bug['id']
			
	        for (updateField in updateFields.entrySet() ) {
				def name = updateField.getKey()
				def value = updateField.getValue()
				
				if (value != null && value.length() > 0) {
				    println "Setting defect " + bug['id'] + " $name to $value"
					switch (name) {
						case "AssignedTo":
						case "Priority":
						case "Status":
						case "Summary":
						case "Project":
						case "DetectedBy":
							bug[name] = value
							break;
						default:
							bug.Field[name] = value
					}
				}
	        }
		        
			println 'Posting changes to defect ' + bug['id']
			bug.Post()
			bug.UnlockObject()
			println 'Post complete'
	    }
	    finally {
	    	if (testDirector) {
		        try {
                    println "Disconnecting ...";
			        if (testDirector.Connected()) {
			            testDirector.Disconnect()
			        }
                    println "Logging out ...";
			        if (testDirector.LoggedIn()) {
			            testDirector.Logout()
			        }
                    println "Releasing connection ...";
		            testDirector.ReleaseConnection()
                    println "Safe Releasing connection ...";
		            testDirector.safeRelease()
                    println "Done With safe Release...";
		        }
		        catch (Exception e) {}
	        }
	    }
	}
}
catch (Exception e) {
	println e.getMessage()
	exitcode = 1
}
com.jacob.com.ComThread.Release();

if (exitcode) {
	System.exit(exitcode)
}
